com.sun.star.lib.uno.helper

## Class ComponentBase

- java.lang.Object
- - com.sun.star.lib.uno.helper.WeakBase
  - - com.sun.star.lib.uno.helper.ComponentBase

- All Implemented Interfaces:
    XComponent, XTypeProvider, XInterface, XWeak
  Direct Known Subclasses:
    Factory, PropertySet

      public class ComponentBase
      extends WeakBase
      implements XComponent

  This class can be used as the base class for UNO components. In addition to the functionality ,which is inherited from WeakBase, it implements com.sun.star.lang.XComponent.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `bDisposed`
    `protected boolean` | `bInDispose`
    `protected MultiTypeInterfaceContainer` | `listenerContainer`

    - ### Fields inherited from class com.sun.star.lib.uno.helper.WeakBase

      `_mapImplementationIds, _mapTypes`

    - ### Fields inherited from interface com.sun.star.lang.XComponent

      `UNOTYPEINFO`

    - ### Fields inherited from interface com.sun.star.uno.XWeak

      `UNOTYPEINFO`

    - ### Fields inherited from interface com.sun.star.lang.XTypeProvider

      `UNOTYPEINFO`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ComponentBase()` Creates a new instance of CompBase

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addEventListener(XEventListener listener)`
    `void` | `dispose()` Method of XComponent.
    `protected void` | `finalize()` Override of Object.finalize.
    `protected void` | `postDisposing()` Override to become notified right before the disposing action is performed.
    `protected void` | `preDisposing()` Override to perform extra clean-up work.
    `void` | `removeEventListener(XEventListener xEventListener)` Method of XComponent.

    - ### Methods inherited from class com.sun.star.lib.uno.helper.WeakBase

      `getImplementationId, getTypes, queryAdapter`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### listenerContainer

          protected MultiTypeInterfaceContainer listenerContainer

    - #### bInDispose

          protected boolean bInDispose

    - #### bDisposed

          protected boolean bDisposed

  - ### Constructor Detail

    - #### ComponentBase

          public ComponentBase()

      Creates a new instance of CompBase

  - ### Method Detail

    - #### preDisposing

          protected void preDisposing()

      Override to perform extra clean-up work. Provided for subclasses. It is called during dispose()

    - #### postDisposing

          protected void postDisposing()

      Override to become notified right before the disposing action is performed.

    - #### dispose

          public void dispose()

      Method of XComponent. It is called by the owning client when the component is not needed anymore. The registered listeners are notified that this method has been called.
      Specified by:
        `dispose` in interface `XComponent`

    - #### removeEventListener

          public void removeEventListener(XEventListener xEventListener)

      Method of XComponent.
      Specified by:
        `removeEventListener` in interface `XComponent`

    - #### addEventListener

          public void addEventListener(XEventListener listener)

      Specified by:
        `addEventListener` in interface `XComponent`

    - #### finalize

          protected void finalize()
                           throws Throwable

      Description copied from class: `WeakBase`
      Override of Object.finalize. When there are no references to this object anymore then the garbage collector calls this method. Thereby causing the adapter object to be notified. The adapter, in turn, notifies all listeners (com.sun.star.uno.XReference)
      Overrides:
        `finalize` in class `WeakBase`
      Throws:
        `Throwable`